// ignore_for_file: non_constant_identifier_names, camel_case_types, missing_return, unused_import, unused_local_variable, dead_code, unnecessary_cast
import 'dart:convert';

import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:foundation_fluttify/foundation_fluttify.dart';
import 'package:tencent_live_fluttify/src/android/android.export.g.dart';
import 'package:tencent_live_fluttify/src/ios/ios.export.g.dart';

import 'enums.dart';

class LivePusher {
  LivePusher._();

  static Future<LivePusher> create({bool enableTouchFocus}) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  com_tencent_rtmp_TXLivePusher _androidPusher;
  TXLivePush _iosPusher;

  com_tencent_rtmp_TXLivePushConfig _androidConfig;
  TXLivePushConfig _iOSConfig;

  final _androidEventDelegate = _AndroidEventDelegate();
  final _iosEventDelegate = _IOSEventDelegate();

  /// 开始预览
  Future<void> startPreview(dynamic preview) async {
    assert(
      preview is com_tencent_rtmp_ui_TXCloudVideoView || preview is UIView,
    );
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 开始推流
  Future<void> startPush(String pushUrl) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 暂停推流
  Future<void> pausePush() async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 停止预览
  Future<void> stopPreview() async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 停止推流
  Future<void> stopPush() async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 设置观众看到的画面清晰度
  ///
  /// [quality]画面清晰度, [adjustBitrate]是否根据网络状态自动调整画质
  Future<void> setVideoQuality(
    Quality quality, {
    bool adjustBitrate = true,
  }) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 设置美颜效果
  ///
  /// [filter] 美颜算法
  /// [beautyLevel] 磨皮等级： 取值为 0-9.取值为 0 时代表关闭美颜效果.默认值: 0,即关闭美颜效果
  /// [whiteningLevel] 美白等级： 取值为 0-9.取值为 0 时代表关闭美白效果.默认值: 0,即关闭美白效果.
  /// [ruddyLevel] 红润等级： 取值为 0-9.取值为 0 时代表关闭美白效果.默认值: 0,即关闭美白效果.
  Future<void> setBeautyFilter(
    BeautyFilter filter, {
    int beautyLevel = 0,
    int whiteningLevel = 0,
    int ruddyLevel = 0,
  }) async {
    assert(filter != null);
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 色彩滤镜效果
  ///
  /// [specialRatio] 设定滤镜的浓度，设置的浓度越高，滤镜效果也就越明显
  Future<void> setFilter(
    Uri image,
    ImageConfiguration imageConfiguration,
    double specialRatio,
  ) async {
    final imageData = await uri2ImageData(imageConfiguration, image,
        package: 'tencent_live_fluttify');
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 切换前后摄像头
  Future<void> switchCamera() async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 打开/关闭闪光灯
  ///
  /// 仅在当前是后置摄像头时有效
  Future<void> turnFlashLight(bool on) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 调整摄像头的焦距
  ///
  /// 可以通过 TXLivePusher 的getMaxZoom()函数获取最大焦距，setZoom的取值范围即为 1 - 最大焦距
  Future<void> setZoom(int zoomLevel) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 设置曝光比例，取值范围从-1到1
  ///
  /// 负数表示调低曝光，-1是最小值，对应getMinExposureCompensation。正数表示调高曝光，1是最大值，对getMaxExposureCompensation。0表示不调整曝光，默认值为0
  Future<void> setExposureCompensation(int zoomLevel) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 观众端的镜像效果
  ///
  /// 调用 TXLivePusher 中的setMirror接口可以设置观众端的镜像效果。之所以说是观众端的镜像效果，
  /// 是因为当主播在使用前置摄像头直播时，自己看到的画面会被 SDK 默认反转，这时主播的体验跟自己照镜子时的体验是保持一致的。
  /// setMirror所影响的是观众端观看到的画面情况.
  Future<void> setMirror(bool mirror) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 横屏推流
  ///
  /// 大多数情况下，主播习惯以“竖屏持握”手机进行直播拍摄，观众端看到的也是竖屏分辨率的画面（例如 540 × 960 这样的分辨率）；
  /// 有时主播也会“横屏持握”手机，这时观众端期望能看到是横屏分辨率的画面（例如 960 × 540 这样的分辨率）
  ///
  /// TXLivePusher 默认推出的是竖屏分辨率的视频画面，如果希望推出横屏分辨率的画面，需要：
  ///   设置 TXLivePushConfig 中的setHomeOrientation改变观众端看到的视频画面的宽高比方向。
  ///   调用 TXLivePusher 中的setRenderRotation接口改变主播端的视频画面的渲染方向。
  Future<void> setRenderRotation(bool portrait) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 隐私模式（垫片推流）
  ///
  /// 有时候主播的一些动作不希望被观众看到，但直播过程中又不能下播，那就可以考虑进入隐私模式。
  /// 在隐私模式下，SDK 可以暂停采集主播手机的摄像头画面以及麦克风声音，并使用一张默认图片作为替代图像进行推流，也就是所谓的“垫片”。
  Future<void> setPauseConfig(
    int pauseTime,
    int pauseFps,
    Uri imageUri,
    ImageConfiguration imageConfiguration,
  ) async {
    final imageData = await uri2ImageData(imageConfiguration, imageUri);
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 播放背景音乐
  ///
  /// 调用 TXLivePush 中的 BGM 相关接口可以实现背景混音功能。背景混音是指主播在直播时可以选取一首歌曲伴唱，
  /// 歌曲会在主播的手机端播放出来，同时也会被混合到音视频流中被观众端听到，所以被称为“混音”
  Future<void> playBGM(String path) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 停止背景音乐
  Future<void> stopBGM() async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 暂停背景音乐
  Future<void> pauseBGM() async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 恢复背景音乐
  Future<void> resumeBGM() async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 麦克风音量大小
  Future<void> setMicVolume(double volume) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 背景音乐音量大小
  Future<void> setBGMVolume(double volume) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 背景音乐音调高低
  Future<void> setBgmPitch(double level) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 设置混音效果
  Future<void> setReverbType(ReverbType type) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 设置变调效果
  Future<void> setVoiceChangerType(VoiceChangerType type) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 设置 Logo 水印
  Future<void> setWatermark(
    Uri watermarkUri,
    ImageConfiguration imageConfiguration, {
    double x,
    double y,
    double width,
    double height,
  }) async {
    final imageData = await uri2ImageData(imageConfiguration, watermarkUri);
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 开始本地录制
  Future<void> startRecord(String videoPath) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 停止本地录制
  Future<void> stopRecord() async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 发送 SEI 消息
  Future<void> sendMessageEx(String message) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }

  /// 事件处理
  ///
  /// [onWaringNetBusy]弱网提醒
  Future<void> setOnEventListener({
    VoidCallback onWaringNetBusy,
    VoidCallback onWaringReconnect,
    VoidCallback onWaringHardwareAccelerationFail,
    VoidCallback onWaringDNSFail,
    VoidCallback onWaringServerConnFail,
    VoidCallback onWaringShakeFail,
    VoidCallback onWaringServerDisconnect,
    VoidCallback onEventConnectSucc,
    VoidCallback onEventPushBegin,
    VoidCallback onEventOpenCameraSuccess,
    VoidCallback onErrorOpenCameraFail,
    VoidCallback onErrorOpenMicFail,
    VoidCallback onErrorVideoEncodeFail,
    VoidCallback onErrorAudioEncodeFail,
    VoidCallback onErrorUnsupportedResolution,
    VoidCallback onErrorUnsupportedSampleRate,
    VoidCallback onErrorNetDisconnect,
  }) async {
    debugPrint('此为付费插件, 请联系qq 382146139购买');
  }
}

class _AndroidEventDelegate extends java_lang_Object
    with com_tencent_rtmp_ITXLivePushListener {
  VoidCallback _onWaringNetBusy;
  VoidCallback _onWaringReconnect;
  VoidCallback _onWaringHardwareAccelerationFail;
  VoidCallback _onWaringDNSFail;
  VoidCallback _onWaringServerConnFail;
  VoidCallback _onWaringShakeFail;
  VoidCallback _onWaringServerDisconnect;

  VoidCallback _onEventConnectSucc;
  VoidCallback _onEventPushBegin;
  VoidCallback _onEventOpenCameraSuccess;

  VoidCallback _onErrorOpenCameraFail;
  VoidCallback _onErrorOpenMicFail;
  VoidCallback _onErrorVideoEncodeFail;
  VoidCallback _onErrorAudioEncodeFail;
  VoidCallback _onErrorUnsupportedResolution;
  VoidCallback _onErrorUnsupportedSampleRate;
  VoidCallback _onErrorNetDisconnect;

  @override
  Future<void> onPushEvent(int var1, android_os_Bundle var2) async {
    super.onPushEvent(var1, var2);
    // 网络环境不佳 1101
    if (var1 == 1101 && _onWaringNetBusy != null) {
      _onWaringNetBusy();
    }
    // 网络断连，已启动自动重连（自动重连连续失败超过三次会放弃） 1102
    else if (var1 == 1102 && _onWaringReconnect != null) {
      _onWaringReconnect();
    }
    // 硬编码启动失败，采用软编码 1103
    else if (var1 == 1103 && _onWaringHardwareAccelerationFail != null) {
      _onWaringHardwareAccelerationFail();
    }
    // RTMP - DNS 解析失败（会触发重试流程） 3001
    else if (var1 == 3001 && _onWaringDNSFail != null) {
      _onWaringDNSFail();
    }
    // RTMP 服务器连接失败（会触发重试流程） 3002
    else if (var1 == 3002 && _onWaringServerConnFail != null) {
      _onWaringServerConnFail();
    }
    // RTMP 服务器握手失败（会触发重试流程） 3003
    else if (var1 == 3003 && _onWaringShakeFail != null) {
      _onWaringShakeFail();
    }
    // RTMP 服务器主动断开连接（会触发重试流程） 3004
    else if (var1 == 3004 && _onWaringServerDisconnect != null) {
      _onWaringServerDisconnect();
    }
    // 已经成功连接到腾讯云推流服务器 1001
    else if (var1 == 1001 && _onEventConnectSucc != null) {
      _onEventConnectSucc();
    }
    // 与服务器握手完毕，一切正常，准备开始推流 1002
    else if (var1 == 1002 && _onEventPushBegin != null) {
      _onEventPushBegin();
    }
    // 推流器已成功打开摄像头（部分 Android 手机在此过程需要耗时1s - 2s） 1003
    else if (var1 == 1003 && _onEventOpenCameraSuccess != null) {
      _onEventOpenCameraSuccess();
    }
    // 打开摄像头失败 -1301
    else if (var1 == -1301 && _onErrorOpenCameraFail != null) {
      _onErrorOpenCameraFail();
    }
    // 打开麦克风失败 -1302
    else if (var1 == -1302 && _onErrorOpenMicFail != null) {
      _onErrorOpenMicFail();
    }
    // 视频编码失败 -1303
    else if (var1 == -1303 && _onErrorVideoEncodeFail != null) {
      _onErrorVideoEncodeFail();
    }
    // 音频编码失败 -1304
    else if (var1 == -1304 && _onErrorAudioEncodeFail != null) {
      _onErrorAudioEncodeFail();
    }
    // 不支持的视频分辨率 -1305
    else if (var1 == -1305 && _onErrorUnsupportedResolution != null) {
      _onErrorUnsupportedResolution();
    }
    // 不支持的音频采样率 -1306
    else if (var1 == -1306 && _onErrorUnsupportedSampleRate != null) {
      _onErrorUnsupportedSampleRate();
    }
    // 网络断连，且经三次重连无效，更多重试请自行重启推流 -1307
    else if (var1 == -1306 && _onErrorNetDisconnect != null) {
      _onErrorNetDisconnect();
    }
  }

  @override
  Future<void> onNetStatus(android_os_Bundle var1) async {
    super.onNetStatus(var1);
  }
}

class _IOSEventDelegate extends NSObject with TXLivePushListener {
  VoidCallback _onWaringNetBusy;
  VoidCallback _onWaringReconnect;
  VoidCallback _onWaringHardwareAccelerationFail;
  VoidCallback _onWaringDNSFail;
  VoidCallback _onWaringServerConnFail;
  VoidCallback _onWaringShakeFail;
  VoidCallback _onWaringServerDisconnect;

  VoidCallback _onEventConnectSucc;
  VoidCallback _onEventPushBegin;
  VoidCallback _onEventOpenCameraSuccess;

  VoidCallback _onErrorOpenCameraFail;
  VoidCallback _onErrorOpenMicFail;
  VoidCallback _onErrorVideoEncodeFail;
  VoidCallback _onErrorAudioEncodeFail;
  VoidCallback _onErrorUnsupportedResolution;
  VoidCallback _onErrorUnsupportedSampleRate;
  VoidCallback _onErrorNetDisconnect;

  @override
  Future<void> onPushEvent_withParam(int EvtID, Map param) async {
    super.onPushEvent_withParam(EvtID, param);
    // 网络环境不佳 1101
    if (EvtID == 1101 && _onWaringNetBusy != null) {
      _onWaringNetBusy();
    }
    // 网络断连，已启动自动重连（自动重连连续失败超过三次会放弃） 1102
    else if (EvtID == 1102 && _onWaringReconnect != null) {
      _onWaringReconnect();
    }
    // 硬编码启动失败，采用软编码 1103
    else if (EvtID == 1103 && _onWaringHardwareAccelerationFail != null) {
      _onWaringHardwareAccelerationFail();
    }
    // RTMP - DNS 解析失败（会触发重试流程） 3001
    else if (EvtID == 3001 && _onWaringDNSFail != null) {
      _onWaringDNSFail();
    }
    // RTMP 服务器连接失败（会触发重试流程） 3002
    else if (EvtID == 3002 && _onWaringServerConnFail != null) {
      _onWaringServerConnFail();
    }
    // RTMP 服务器握手失败（会触发重试流程） 3003
    else if (EvtID == 3003 && _onWaringShakeFail != null) {
      _onWaringShakeFail();
    }
    // RTMP 服务器主动断开连接（会触发重试流程） 3004
    else if (EvtID == 3004 && _onWaringServerDisconnect != null) {
      _onWaringServerDisconnect();
    }
    // 已经成功连接到腾讯云推流服务器 1001
    else if (EvtID == 1001 && _onEventConnectSucc != null) {
      _onEventConnectSucc();
    }
    // 与服务器握手完毕，一切正常，准备开始推流 1002
    else if (EvtID == 1002 && _onEventPushBegin != null) {
      _onEventPushBegin();
    }
    // 推流器已成功打开摄像头（部分 Android 手机在此过程需要耗时1s - 2s） 1003
    else if (EvtID == 1003 && _onEventOpenCameraSuccess != null) {
      _onEventOpenCameraSuccess();
    }
    // 打开摄像头失败 -1301
    else if (EvtID == -1301 && _onErrorOpenCameraFail != null) {
      _onErrorOpenCameraFail();
    }
    // 打开麦克风失败 -1302
    else if (EvtID == -1302 && _onErrorOpenMicFail != null) {
      _onErrorOpenMicFail();
    }
    // 视频编码失败 -1303
    else if (EvtID == -1303 && _onErrorVideoEncodeFail != null) {
      _onErrorVideoEncodeFail();
    }
    // 音频编码失败 -1304
    else if (EvtID == -1304 && _onErrorAudioEncodeFail != null) {
      _onErrorAudioEncodeFail();
    }
    // 不支持的视频分辨率 -1305
    else if (EvtID == -1305 && _onErrorUnsupportedResolution != null) {
      _onErrorUnsupportedResolution();
    }
    // 不支持的音频采样率 -1306
    else if (EvtID == -1306 && _onErrorUnsupportedSampleRate != null) {
      _onErrorUnsupportedSampleRate();
    }
    // 网络断连，且经三次重连无效，更多重试请自行重启推流 -1307
    else if (EvtID == -1306 && _onErrorNetDisconnect != null) {
      _onErrorNetDisconnect();
    }
  }

  @override
  Future<void> onNetStatus(Map param) async {
    super.onNetStatus(param);
  }
}
